use std::error::Error;
use log::info;
use serde::de::DeserializeOwned;
use tokio::{fs::File, io::AsyncReadExt};

pub mod json_object;

pub async fn parse<T>(path: &str) -> Result<T, Box<dyn Error>>
where
    T: DeserializeOwned,
{
    let mut json_string: String = String::new();
    let json_size: usize = File::open(path).await?.read_to_string(&mut json_string).await?;
    info!("From file {path} read {json_size} bytes");
    let json_object: T = serde_json::from_str(&json_string)?;
    Ok(json_object)
}
